|
|
dd59ef |
diff -urNp coreutils-8.22-orig/src/copy.c coreutils-8.22/src/copy.c
|
|
|
dd59ef |
--- coreutils-8.22-orig/src/copy.c 2015-07-03 14:42:56.829772551 +0200
|
|
|
dd59ef |
+++ coreutils-8.22/src/copy.c 2015-07-03 14:51:05.371383675 +0200
|
|
|
dd59ef |
@@ -1292,20 +1292,12 @@ close_src_desc:
|
|
|
dd59ef |
copy a regular file onto a symlink that points to it.
|
|
|
dd59ef |
Try to minimize the cost of this function in the common case.
|
|
|
dd59ef |
Set *RETURN_NOW if we've determined that the caller has no more
|
|
|
dd59ef |
- work to do and should return successfully, right away.
|
|
|
dd59ef |
-
|
|
|
dd59ef |
- Set *UNLINK_SRC if we've determined that the caller wants to do
|
|
|
dd59ef |
- 'rename (a, b)' where 'a' and 'b' are distinct hard links to the same
|
|
|
dd59ef |
- file. In that case, the caller should try to unlink 'a' and then return
|
|
|
dd59ef |
- successfully. Ideally, we wouldn't have to do that, and we'd be
|
|
|
dd59ef |
- able to rely on rename to remove the source file. However, POSIX
|
|
|
dd59ef |
- mistakenly requires that such a rename call do *nothing* and return
|
|
|
dd59ef |
- successfully. */
|
|
|
dd59ef |
+ work to do and should return successfully, right away. */
|
|
|
dd59ef |
|
|
|
dd59ef |
static bool
|
|
|
dd59ef |
same_file_ok (char const *src_name, struct stat const *src_sb,
|
|
|
dd59ef |
char const *dst_name, struct stat const *dst_sb,
|
|
|
dd59ef |
- const struct cp_options *x, bool *return_now, bool *unlink_src)
|
|
|
dd59ef |
+ const struct cp_options *x, bool *return_now)
|
|
|
dd59ef |
{
|
|
|
dd59ef |
const struct stat *src_sb_link;
|
|
|
dd59ef |
const struct stat *dst_sb_link;
|
|
|
dd59ef |
@@ -1316,7 +1308,6 @@ same_file_ok (char const *src_name, stru
|
|
|
dd59ef |
bool same = SAME_INODE (*src_sb, *dst_sb);
|
|
|
dd59ef |
|
|
|
dd59ef |
*return_now = false;
|
|
|
dd59ef |
- *unlink_src = false;
|
|
|
dd59ef |
|
|
|
dd59ef |
/* FIXME: this should (at the very least) be moved into the following
|
|
|
dd59ef |
if-block. More likely, it should be removed, because it inhibits
|
|
|
dd59ef |
@@ -1348,14 +1339,11 @@ same_file_ok (char const *src_name, stru
|
|
|
dd59ef |
/* Here we have two symlinks that are hard-linked together,
|
|
|
dd59ef |
and we're not making backups. In this unusual case, simply
|
|
|
dd59ef |
returning true would lead to mv calling "rename(A,B)",
|
|
|
dd59ef |
- which would do nothing and return 0. I.e., A would
|
|
|
dd59ef |
- not be removed. Hence, the solution is to tell the
|
|
|
dd59ef |
- caller that all it must do is unlink A and return. */
|
|
|
dd59ef |
+ which would do nothing and return 0. */
|
|
|
dd59ef |
if (same_link)
|
|
|
dd59ef |
{
|
|
|
dd59ef |
- *unlink_src = true;
|
|
|
dd59ef |
*return_now = true;
|
|
|
dd59ef |
- return true;
|
|
|
dd59ef |
+ return ! x->move_mode;
|
|
|
dd59ef |
}
|
|
|
dd59ef |
}
|
|
|
dd59ef |
|
|
|
dd59ef |
@@ -1443,26 +1431,22 @@ same_file_ok (char const *src_name, stru
|
|
|
dd59ef |
return true;
|
|
|
dd59ef |
#endif
|
|
|
dd59ef |
|
|
|
dd59ef |
- /* They may refer to the same file if we're in move mode and the
|
|
|
dd59ef |
- target is a symlink. That is ok, since we remove any existing
|
|
|
dd59ef |
- destination file before opening it -- via 'rename' if they're on
|
|
|
dd59ef |
- the same file system, via 'unlink (DST_NAME)' otherwise.
|
|
|
dd59ef |
- It's also ok if they're distinct hard links to the same file. */
|
|
|
dd59ef |
if (x->move_mode || x->unlink_dest_before_opening)
|
|
|
dd59ef |
{
|
|
|
dd59ef |
+ /* They may refer to the same file if we're in move mode and the
|
|
|
dd59ef |
+ target is a symlink. That is ok, since we remove any existing
|
|
|
dd59ef |
+ destination file before opening it -- via 'rename' if they're on
|
|
|
dd59ef |
+ the same file system, via 'unlink (DST_NAME)' otherwise. */
|
|
|
dd59ef |
if (S_ISLNK (dst_sb_link->st_mode))
|
|
|
dd59ef |
return true;
|
|
|
dd59ef |
|
|
|
dd59ef |
+ /* It's not ok if they're distinct hard links to the same file as
|
|
|
dd59ef |
+ this causes a race condition and we may lose data in this case. */
|
|
|
dd59ef |
if (same_link
|
|
|
dd59ef |
&& 1 < dst_sb_link->st_nlink
|
|
|
dd59ef |
&& ! same_name (src_name, dst_name))
|
|
|
dd59ef |
{
|
|
|
dd59ef |
- if (x->move_mode)
|
|
|
dd59ef |
- {
|
|
|
dd59ef |
- *unlink_src = true;
|
|
|
dd59ef |
- *return_now = true;
|
|
|
dd59ef |
- }
|
|
|
dd59ef |
- return true;
|
|
|
dd59ef |
+ return ! x->move_mode;
|
|
|
dd59ef |
}
|
|
|
dd59ef |
}
|
|
|
dd59ef |
|
|
|
dd59ef |
@@ -1820,11 +1804,10 @@ copy_internal (char const *src_name, cha
|
|
|
dd59ef |
{ /* Here, we know that dst_name exists, at least to the point
|
|
|
dd59ef |
that it is stat'able or lstat'able. */
|
|
|
dd59ef |
bool return_now;
|
|
|
dd59ef |
- bool unlink_src;
|
|
|
dd59ef |
|
|
|
dd59ef |
have_dst_lstat = !use_stat;
|
|
|
dd59ef |
if (! same_file_ok (src_name, &src_sb, dst_name, &dst_sb,
|
|
|
dd59ef |
- x, &return_now, &unlink_src))
|
|
|
dd59ef |
+ x, &return_now))
|
|
|
dd59ef |
{
|
|
|
dd59ef |
error (0, 0, _("%s and %s are the same file"),
|
|
|
dd59ef |
quote_n (0, src_name), quote_n (1, dst_name));
|
|
|
dd59ef |
@@ -1883,22 +1866,14 @@ copy_internal (char const *src_name, cha
|
|
|
dd59ef |
cp and mv treat -i and -f differently. */
|
|
|
dd59ef |
if (x->move_mode)
|
|
|
dd59ef |
{
|
|
|
dd59ef |
- if (abandon_move (x, dst_name, &dst_sb)
|
|
|
dd59ef |
- || (unlink_src && unlink (src_name) == 0))
|
|
|
dd59ef |
+ if (abandon_move (x, dst_name, &dst_sb))
|
|
|
dd59ef |
{
|
|
|
dd59ef |
/* Pretend the rename succeeded, so the caller (mv)
|
|
|
dd59ef |
doesn't end up removing the source file. */
|
|
|
dd59ef |
if (rename_succeeded)
|
|
|
dd59ef |
*rename_succeeded = true;
|
|
|
dd59ef |
- if (unlink_src && x->verbose)
|
|
|
dd59ef |
- printf (_("removed %s\n"), quote (src_name));
|
|
|
dd59ef |
return true;
|
|
|
dd59ef |
}
|
|
|
dd59ef |
- if (unlink_src)
|
|
|
dd59ef |
- {
|
|
|
dd59ef |
- error (0, errno, _("cannot remove %s"), quote (src_name));
|
|
|
dd59ef |
- return false;
|
|
|
dd59ef |
- }
|
|
|
dd59ef |
}
|
|
|
dd59ef |
else
|
|
|
dd59ef |
{
|
|
|
dd59ef |
diff -urNp coreutils-8.22-orig/tests/cp/same-file.sh coreutils-8.22/tests/cp/same-file.sh
|
|
|
dd59ef |
--- coreutils-8.22-orig/tests/cp/same-file.sh 2013-12-04 15:48:30.000000000 +0100
|
|
|
dd59ef |
+++ coreutils-8.22/tests/cp/same-file.sh 2015-07-03 14:54:12.539772880 +0200
|
|
|
dd59ef |
@@ -36,7 +36,7 @@ ln dangling-slink hard-link > /dev/null 2>&1 \
|
|
|
dd59ef |
rm -f no-such dangling-slink hard-link
|
|
|
dd59ef |
|
|
|
dd59ef |
test $hard_link_to_symlink_does_the_deref = yes \
|
|
|
dd59ef |
- && remove_these_sed='/^0 -[bf]*l .*sl1 ->/d' \
|
|
|
dd59ef |
+ && remove_these_sed='/^0 -[bf]*l .*sl1 ->/d; /hlsl/d' \
|
|
|
dd59ef |
|| remove_these_sed='/^ELIDE NO TEST OUTPUT/d'
|
|
|
dd59ef |
|
|
|
dd59ef |
exec 3>&1 1> actual
|
|
|
dd59ef |
@@ -44,7 +44,8 @@ exec 3>&1 1> actual
|
|
|
dd59ef |
# FIXME: This should be bigger: like more than 8k
|
|
|
dd59ef |
contents=XYZ
|
|
|
dd59ef |
|
|
|
dd59ef |
-for args in 'foo symlink' 'symlink foo' 'foo foo' 'sl1 sl2' 'foo hardlink'; do
|
|
|
dd59ef |
+for args in 'foo symlink' 'symlink foo' 'foo foo' 'sl1 sl2' \
|
|
|
dd59ef |
+ 'foo hardlink' 'hlsl sl2'; do
|
|
|
dd59ef |
for options in '' -d -f -df --rem -b -bd -bf -bdf \
|
|
|
dd59ef |
-l -dl -fl -dfl -bl -bdl -bfl -bdfl; do
|
|
|
dd59ef |
case $args$options in
|
|
|
dd59ef |
@@ -76,6 +77,8 @@ for args in 'foo symlink' 'symlink foo'
|
|
|
dd59ef |
continue ;;
|
|
|
dd59ef |
'yes:sl1 sl2:-bfl')
|
|
|
dd59ef |
continue ;;
|
|
|
dd59ef |
+ yes:hlsl*)
|
|
|
dd59ef |
+ continue ;;
|
|
|
dd59ef |
esac
|
|
|
dd59ef |
|
|
|
dd59ef |
rm -rf dir
|
|
|
dd59ef |
@@ -86,6 +87,7 @@ for args in 'foo symlink' 'symlink foo'
|
|
|
dd59ef |
case "$args" in *hardlink*) ln foo hardlink ;; esac
|
|
|
dd59ef |
case "$args" in *sl1*) ln -s foo sl1;; esac
|
|
|
dd59ef |
case "$args" in *sl2*) ln -s foo sl2;; esac
|
|
|
dd59ef |
+ case "$args" in *hlsl*) ln sl2 hlsl;;esac
|
|
|
dd59ef |
(
|
|
|
dd59ef |
(
|
|
|
dd59ef |
# echo 1>&2 cp $options $args
|
|
|
dd59ef |
@@ -211,6 +213,24 @@ cat <<\EOF | sed "$remove_these_sed" > e
|
|
|
dd59ef |
0 -bfl (foo hardlink)
|
|
|
dd59ef |
0 -bdfl (foo hardlink)
|
|
|
dd59ef |
|
|
|
dd59ef |
+1 [cp: 'hlsl' and 'sl2' are the same file] (foo hlsl -> foo sl2 -> foo)
|
|
|
dd59ef |
+0 -d (foo hlsl -> foo sl2 -> foo)
|
|
|
dd59ef |
+1 -f [cp: 'hlsl' and 'sl2' are the same file] (foo hlsl -> foo sl2 -> foo)
|
|
|
dd59ef |
+0 -df (foo hlsl -> foo sl2 -> foo)
|
|
|
dd59ef |
+0 --rem (foo hlsl -> foo sl2)
|
|
|
dd59ef |
+0 -b (foo hlsl -> foo sl2 sl2.~1~ -> foo)
|
|
|
dd59ef |
+0 -bd (foo hlsl -> foo sl2 -> foo sl2.~1~ -> foo)
|
|
|
dd59ef |
+0 -bf (foo hlsl -> foo sl2 sl2.~1~ -> foo)
|
|
|
dd59ef |
+0 -bdf (foo hlsl -> foo sl2 -> foo sl2.~1~ -> foo)
|
|
|
dd59ef |
+1 -l [cp: cannot create hard link 'sl2' to 'hlsl'] (foo hlsl -> foo sl2 -> foo)
|
|
|
dd59ef |
+0 -dl (foo hlsl -> foo sl2 -> foo)
|
|
|
dd59ef |
+0 -fl (foo hlsl -> foo sl2)
|
|
|
dd59ef |
+0 -dfl (foo hlsl -> foo sl2 -> foo)
|
|
|
dd59ef |
+0 -bl (foo hlsl -> foo sl2 sl2.~1~ -> foo)
|
|
|
dd59ef |
+0 -bdl (foo hlsl -> foo sl2 -> foo)
|
|
|
dd59ef |
+0 -bfl (foo hlsl -> foo sl2 sl2.~1~ -> foo)
|
|
|
dd59ef |
+0 -bdfl (foo hlsl -> foo sl2 -> foo)
|
|
|
dd59ef |
+
|
|
|
dd59ef |
EOF
|
|
|
dd59ef |
|
|
|
dd59ef |
exec 1>&3 3>&-
|
|
|
dd59ef |
diff -urNp coreutils-8.22-orig/tests/local.mk coreutils-8.22/tests/local.mk
|
|
|
dd59ef |
--- coreutils-8.22-orig/tests/local.mk 2015-07-03 14:42:56.820772485 +0200
|
|
|
dd59ef |
+++ coreutils-8.22/tests/local.mk 2015-07-03 14:55:07.060176869 +0200
|
|
|
dd59ef |
@@ -591,7 +591,6 @@ all_tests = \
|
|
|
dd59ef |
tests/mv/hard-3.sh \
|
|
|
dd59ef |
tests/mv/hard-4.sh \
|
|
|
dd59ef |
tests/mv/hard-link-1.sh \
|
|
|
dd59ef |
- tests/mv/hard-verbose.sh \
|
|
|
dd59ef |
tests/mv/i-1.pl \
|
|
|
dd59ef |
tests/mv/i-2.sh \
|
|
|
dd59ef |
tests/mv/i-3.sh \
|
|
|
dd59ef |
diff -urNp coreutils-8.22-orig/tests/mv/force.sh coreutils-8.22/tests/mv/force.sh
|
|
|
dd59ef |
--- coreutils-8.22-orig/tests/mv/force.sh 2013-12-04 15:48:30.000000000 +0100
|
|
|
dd59ef |
+++ coreutils-8.22/tests/mv/force.sh 2015-07-03 14:56:42.840885931 +0200
|
|
|
dd59ef |
@@ -25,18 +25,19 @@ ff2=mvforce2
|
|
|
dd59ef |
echo force-contents > $ff || framework_failure_
|
|
|
dd59ef |
ln $ff $ff2 || framework_failure_
|
|
|
dd59ef |
|
|
|
dd59ef |
-# This mv command should exit nonzero.
|
|
|
dd59ef |
-mv $ff $ff > out 2>&1 && fail=1
|
|
|
dd59ef |
+# mv should fail for the same name, or separate hardlinks as in
|
|
|
dd59ef |
+# both cases rename() will do nothing and return success.
|
|
|
dd59ef |
+# One could unlink(src) in the hardlink case, but that would
|
|
|
dd59ef |
+# introduce races with overlapping mv instances removing both hardlinks.
|
|
|
dd59ef |
|
|
|
dd59ef |
-cat > exp <
|
|
|
dd59ef |
-mv: '$ff' and '$ff' are the same file
|
|
|
dd59ef |
-EOF
|
|
|
dd59ef |
+for dest in $ff $ff2; do
|
|
|
dd59ef |
+ # This mv command should exit nonzero.
|
|
|
dd59ef |
+ mv $ff $dest > out 2>&1 && fail=1
|
|
|
dd59ef |
|
|
|
dd59ef |
-compare exp out || fail=1
|
|
|
dd59ef |
-test $(cat $ff) = force-contents || fail=1
|
|
|
dd59ef |
+ printf "mv: '$ff' and '$dest' are the same file\n" > exp
|
|
|
dd59ef |
+ compare exp out || fail=1
|
|
|
dd59ef |
|
|
|
dd59ef |
-# This should succeed, even though the source and destination
|
|
|
dd59ef |
-# device and inodes are the same.
|
|
|
dd59ef |
-mv $ff $ff2 || fail=1
|
|
|
dd59ef |
+ test $(cat $ff) = force-contents || fail=1
|
|
|
dd59ef |
+done
|
|
|
dd59ef |
|
|
|
dd59ef |
Exit $fail
|
|
|
dd59ef |
diff -urNp coreutils-8.22-orig/tests/mv/hard-4.sh coreutils-8.22/tests/mv/hard-4.sh
|
|
|
dd59ef |
--- coreutils-8.22-orig/tests/mv/hard-4.sh 2013-12-04 15:48:30.000000000 +0100
|
|
|
dd59ef |
+++ coreutils-8.22/tests/mv/hard-4.sh 2015-07-03 14:58:31.179687188 +0200
|
|
|
dd59ef |
@@ -1,5 +1,5 @@
|
|
|
dd59ef |
#!/bin/sh
|
|
|
dd59ef |
-# ensure that mv removes a in this case: touch a; ln a b; mv a b
|
|
|
dd59ef |
+# ensure that mv maintains a in this case: touch a; ln a b; mv a b
|
|
|
dd59ef |
|
|
|
dd59ef |
# Copyright (C) 2003-2013 Free Software Foundation, Inc.
|
|
|
dd59ef |
|
|
|
dd59ef |
@@ -21,15 +21,19 @@ print_ver_ mv
|
|
|
dd59ef |
touch a || framework_failure_
|
|
|
dd59ef |
ln a b || framework_failure_
|
|
|
dd59ef |
|
|
|
dd59ef |
+# Between coreutils-5.0 and coreutils-8.24, 'a' would be removed.
|
|
|
dd59ef |
+# Before coreutils-5.0.1 the issue would not have been diagnosed.
|
|
|
dd59ef |
+# We don't emulate the rename(a,b) with unlink(a) as that would
|
|
|
dd59ef |
+# introduce races with overlapping mv instances removing both links.
|
|
|
dd59ef |
+mv a b 2>err && fail=1
|
|
|
dd59ef |
+printf "mv: 'a' and 'b' are the same file\n" > exp
|
|
|
dd59ef |
+compare exp err || fail=1
|
|
|
dd59ef |
|
|
|
dd59ef |
-mv a b || fail=1
|
|
|
dd59ef |
|
|
|
dd59ef |
-# In coreutils-5.0 and earlier, a would not be removed.
|
|
|
dd59ef |
-test -r a && fail=1
|
|
|
dd59ef |
+test -r a || fail=1
|
|
|
dd59ef |
test -r b || fail=1
|
|
|
dd59ef |
|
|
|
dd59ef |
-# Make sure it works also with --backup.
|
|
|
dd59ef |
-ln b a
|
|
|
dd59ef |
+# Make sure it works with --backup.
|
|
|
dd59ef |
mv --backup=simple a b || fail=1
|
|
|
dd59ef |
test -r a && fail=1
|
|
|
dd59ef |
test -r b || fail=1
|
|
|
dd59ef |
diff -urNp coreutils-8.22-orig/tests/mv/i-4.sh coreutils-8.22/tests/mv/i-4.sh
|
|
|
dd59ef |
--- coreutils-8.22-orig/tests/mv/i-4.sh 2013-12-04 15:48:30.000000000 +0100
|
|
|
dd59ef |
+++ coreutils-8.22/tests/mv/i-4.sh 2015-07-03 15:00:39.533718254 +0200
|
|
|
dd59ef |
@@ -23,6 +23,7 @@ for i in a b; do
|
|
|
dd59ef |
echo $i > $i || framework_failure_
|
|
|
dd59ef |
done
|
|
|
dd59ef |
echo y > y || framework_failure_
|
|
|
dd59ef |
+echo n > n || framework_failure_
|
|
|
dd59ef |
|
|
|
dd59ef |
mv -i a b < y >/dev/null 2>&1 || fail=1
|
|
|
dd59ef |
|
|
|
dd59ef |
@@ -32,18 +33,15 @@ case "$(cat b)" in
|
|
|
dd59ef |
*) fail=1 ;;
|
|
|
dd59ef |
esac
|
|
|
dd59ef |
|
|
|
dd59ef |
-# Ensure that mv -i a b works properly with 'n' and 'y'
|
|
|
dd59ef |
-# responses, even when a and b are hard links to the same file.
|
|
|
dd59ef |
-# This 'n' test would fail (no prompt) for coreutils-5.0.1 through 5.3.0.
|
|
|
dd59ef |
-echo n > n
|
|
|
dd59ef |
+# Ensure that mv -i a b works properly with 'n' and 'y' responses,
|
|
|
dd59ef |
+# when a and b are hard links to the same file.
|
|
|
dd59ef |
rm -f a b
|
|
|
dd59ef |
echo a > a
|
|
|
dd59ef |
ln a b
|
|
|
dd59ef |
-mv -i a b < n >/dev/null 2>&1 || fail=1
|
|
|
dd59ef |
+mv -i a b < y 2>err && fail=1
|
|
|
dd59ef |
test -r a || fail=1
|
|
|
dd59ef |
test -r b || fail=1
|
|
|
dd59ef |
-mv -i a b < y >/dev/null 2>&1 || fail=1
|
|
|
dd59ef |
-test -r a && fail=1
|
|
|
dd59ef |
-test -r b || fail=1
|
|
|
dd59ef |
+printf "mv: 'a' and 'b' are the same file\n" > exp
|
|
|
dd59ef |
+compare exp err || fail=1
|
|
|
dd59ef |
|
|
|
dd59ef |
Exit $fail
|
|
|
dd59ef |
diff -urNp coreutils-8.22-orig/tests/mv/symlink-onto-hardlink-to-self.sh coreutils-8.22/tests/mv/symlink-onto-hardlink-to-self.sh
|
|
|
dd59ef |
--- coreutils-8.22-orig/tests/mv/symlink-onto-hardlink-to-self.sh 2013-12-04 15:48:30.000000000 +0100
|
|
|
dd59ef |
+++ coreutils-8.22/tests/mv/symlink-onto-hardlink-to-self.sh 2015-07-03 15:01:39.209190741 +0200
|
|
|
dd59ef |
@@ -1,10 +1,10 @@
|
|
|
dd59ef |
#!/bin/sh
|
|
|
dd59ef |
-# Demonstrate that when moving a symlink onto a hardlink-to-that-symlink, the
|
|
|
dd59ef |
-# source symlink is removed. Depending on your kernel (e.g., Linux, Solaris,
|
|
|
dd59ef |
+# Demonstrate that when moving a symlink onto a hardlink-to-that-symlink,
|
|
|
dd59ef |
+# an error is presented. Depending on your kernel (e.g., Linux, Solaris,
|
|
|
dd59ef |
# but not NetBSD), prior to coreutils-8.16, the mv would successfully perform
|
|
|
dd59ef |
# a no-op. I.e., surprisingly, mv s1 s2 would succeed, yet fail to remove s1.
|
|
|
dd59ef |
|
|
|
dd59ef |
-# Copyright (C) 2012-2013 Free Software Foundation, Inc.
|
|
|
dd59ef |
+# Copyright (C) 2012-2014 Free Software Foundation, Inc.
|
|
|
dd59ef |
|
|
|
dd59ef |
# This program is free software: you can redistribute it and/or modify
|
|
|
dd59ef |
# it under the terms of the GNU General Public License as published by
|
|
|
dd59ef |
@@ -26,27 +26,34 @@ print_ver_ mv
|
|
|
dd59ef |
touch f || framework_failure_
|
|
|
dd59ef |
ln -s f s2 || framework_failure_
|
|
|
dd59ef |
|
|
|
dd59ef |
-for opt in '' --backup; do
|
|
|
dd59ef |
+# Attempt to create a hard link to that symlink.
|
|
|
dd59ef |
+# On some systems, it's not possible: they create a hard link to the referent.
|
|
|
dd59ef |
+ln s2 s1 || framework_failure_
|
|
|
dd59ef |
+
|
|
|
dd59ef |
+# If s1 is not a symlink, skip this test.
|
|
|
dd59ef |
+test -h s1 \
|
|
|
dd59ef |
+ || skip_ your kernel or file system cannot create a hard link to a symlink
|
|
|
dd59ef |
|
|
|
dd59ef |
- # Attempt to create a hard link to that symlink.
|
|
|
dd59ef |
- # On some systems, it's not possible: they create a hard link to the referent.
|
|
|
dd59ef |
- ln s2 s1 || framework_failure_
|
|
|
dd59ef |
-
|
|
|
dd59ef |
- # If s1 is not a symlink, skip this test.
|
|
|
dd59ef |
- test -h s1 \
|
|
|
dd59ef |
- || skip_ your kernel or file system cannot create a hard link to a symlink
|
|
|
dd59ef |
+for opt in '' --backup; do
|
|
|
dd59ef |
|
|
|
dd59ef |
- mv $opt s1 s2 > out 2>&1 || fail=1
|
|
|
dd59ef |
- compare /dev/null out || fail=1
|
|
|
dd59ef |
+ if test "$opt" = --backup; then
|
|
|
dd59ef |
+ mv $opt s1 s2 > out 2>&1 || fail=1
|
|
|
dd59ef |
+ compare /dev/null out || fail=1
|
|
|
dd59ef |
|
|
|
dd59ef |
- # Ensure that s1 is gone.
|
|
|
dd59ef |
- test -e s1 && fail=1
|
|
|
dd59ef |
+ # Ensure that s1 is gone.
|
|
|
dd59ef |
+ test -e s1 && fail=1
|
|
|
dd59ef |
|
|
|
dd59ef |
- if test "$opt" = --backup; then
|
|
|
dd59ef |
# With --backup, ensure that the backup file was created.
|
|
|
dd59ef |
ref=$(readlink s2~) || fail=1
|
|
|
dd59ef |
test "$ref" = f || fail=1
|
|
|
dd59ef |
else
|
|
|
dd59ef |
+ echo "mv: 's1' and 's2' are the same file" > exp
|
|
|
dd59ef |
+ mv $opt s1 s2 2>err && fail=1
|
|
|
dd59ef |
+ compare exp err || fail=1
|
|
|
dd59ef |
+
|
|
|
dd59ef |
+ # Ensure that s1 is still present.
|
|
|
dd59ef |
+ test -e s1 || fail=1
|
|
|
dd59ef |
+
|
|
|
dd59ef |
# Without --backup, ensure there is no backup file.
|
|
|
dd59ef |
test -e s2~ && fail=1
|
|
|
dd59ef |
fi
|